#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "prefcallbacks.h"
#include "preferences.h"
#include "prefsupport.h"

GtkWidget* historyLength;
GtkWidget* itemLength;
GtkWidget* primaryCheck;
GtkWidget* defaultCheck;
GtkWidget* markDefaultCheck;
GtkWidget* saveHistCheck;
GtkWidget* prefWin;

//Die Variablen aus der main.c:
extern int maxElements; 
extern int maxItemLength;
extern gboolean usePrimary; 
extern gboolean useDefault; 
extern gboolean markDefault; 
extern gboolean weSaveHistory;
void savePreferences();
void applyPreferences();

void setWidgets()
{
	gtk_spin_button_set_value((GtkSpinButton*)historyLength, maxElements);
	gtk_spin_button_set_value((GtkSpinButton*)itemLength, maxItemLength);
	gtk_toggle_button_set_active((GtkToggleButton*)primaryCheck, usePrimary);
	gtk_toggle_button_set_active((GtkToggleButton*)defaultCheck, useDefault);
	gtk_toggle_button_set_active((GtkToggleButton*)markDefaultCheck, markDefault);
	gtk_toggle_button_set_active((GtkToggleButton*)saveHistCheck, weSaveHistory);
	on_clipCheck_toggled(NULL, NULL); //kann markDefaultCheck ggf. unsensitive machen
}

void giveWindow(GtkWidget* window)
{
	/*Da Glade die ganzen Datentypen "versteckt", müssen wir uns die alle selber raussuchen :/ */
	prefWin = window;
	GtkWidget* vbox5 = gtk_bin_get_child((GtkBin*)window);
	GtkWidget* frame1 = (GtkWidget*)gtk_container_get_children((GtkContainer*)vbox5)->data;
	GtkWidget* alignment1 = gtk_bin_get_child((GtkBin*)frame1);
	GtkWidget* vbox2 = gtk_bin_get_child((GtkBin*)alignment1);
	GtkWidget* hbox1 = (GtkWidget*)gtk_container_get_children((GtkContainer*)vbox2)->data;
	historyLength = (GtkWidget*)gtk_container_get_children((GtkContainer*)hbox1)->next->data;
	GtkWidget* hbox2 = (GtkWidget*)gtk_container_get_children((GtkContainer*)vbox2)->next->data;
	itemLength = (GtkWidget*)gtk_container_get_children((GtkContainer*)hbox2)->next->data;
	GtkWidget* frame2 = (GtkWidget*)gtk_container_get_children((GtkContainer*)vbox2)->next->next->next->data;
	GtkWidget* alignment2 = gtk_bin_get_child((GtkBin*)frame2);
	GtkWidget* vbox4 = gtk_bin_get_child((GtkBin*)alignment2);
	primaryCheck = (GtkWidget*)gtk_container_get_children((GtkContainer*)vbox4)->data;
	defaultCheck = (GtkWidget*)gtk_container_get_children((GtkContainer*)vbox4)->next->data;
	markDefaultCheck = (GtkWidget*)gtk_container_get_children((GtkContainer*)vbox2)->next->next->next
		->next->next->data;
	saveHistCheck = (GtkWidget*)gtk_container_get_children((GtkContainer*)vbox2)->next->next->next->next
		->next->next->next->data;
	setWidgets();

	/*looool Oh mann bin ich doof. Um genau das hier zu tun, gibt es ja lookup_widget in prefsupport.h*/
	/*Egal, jetzt bleibt das hier so. Guckt sich ja eh keiner an :> */
}

void
on_clipCheck_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if (!(gtk_toggle_button_get_active((GtkToggleButton*)primaryCheck) && 
	  gtk_toggle_button_get_active((GtkToggleButton*)defaultCheck)))
		gtk_widget_set_sensitive(markDefaultCheck, FALSE);
	else
		gtk_widget_set_sensitive(markDefaultCheck, TRUE);
}


void
on_closeButton_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	maxElements = gtk_spin_button_get_value_as_int((GtkSpinButton*)historyLength); 
	maxItemLength = gtk_spin_button_get_value_as_int((GtkSpinButton*)itemLength); 
	usePrimary = gtk_toggle_button_get_active((GtkToggleButton*)primaryCheck);
	useDefault = gtk_toggle_button_get_active((GtkToggleButton*)defaultCheck);
	markDefault = gtk_toggle_button_get_active((GtkToggleButton*)markDefaultCheck);
	weSaveHistory = gtk_toggle_button_get_active((GtkToggleButton*)saveHistCheck);
	savePreferences();
	applyPreferences();
	gtk_widget_destroy(prefWin);
}

